"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ShadowScrollComponent = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactResizeDetector = _interopRequireDefault(require("react-resize-detector"));

var _reactJss = _interopRequireDefault(require("react-jss"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ShadowScrollComponent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ShadowScrollComponent, _React$Component);

  function ShadowScrollComponent(props) {
    var _this;

    _classCallCheck(this, ShadowScrollComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ShadowScrollComponent).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "resizeTags", function () {
      if (_this.ref.current.clientHeight < _this.ref.current.scrollHeight) {
        _this.setState({
          scroll: true
        });
      } else {
        _this.setState({
          scroll: false
        });
      }
    });

    _this.state = {
      scroll: false
    };
    _this.ref = _react["default"].createRef();
    return _this;
  }

  _createClass(ShadowScrollComponent, [{
    key: "render",
    value: function render() {
      var classes = this.props.classes;
      return _react["default"].createElement("div", {
        className: "".concat(classes.container, " ").concat(this.state.scroll ? classes.containerScroll : '')
      }, _react["default"].createElement("div", {
        ref: this.ref,
        className: classes.subcontainer
      }, this.props.children, _react["default"].createElement(_reactResizeDetector["default"], {
        handleHeight: true,
        onResize: this.resizeTags
      })));
    }
  }]);

  return ShadowScrollComponent;
}(_react["default"].Component);

exports.ShadowScrollComponent = ShadowScrollComponent;
ShadowScrollComponent.propTypes = {
  scrollColor: _propTypes["default"].string,
  scrollColorHover: _propTypes["default"].string,
  scrollWidth: _propTypes["default"].number,
  isShadow: _propTypes["default"].bool,
  shadow: _propTypes["default"].string
};
ShadowScrollComponent.defaultProps = {
  scrollColor: '#c5c5c5',
  scrollColorHover: '#a6a6a6',
  scrollWidth: 8,
  scrollPadding: 0,
  isShadow: true,
  shadow: '0 2px 4px rgba(0, 0, 0, 0.2) inset, 0 -2px 4px rgba(0, 0, 0, 0.2) inset'
};
var styles = {
  containerScroll: {
    padding: function padding(props) {
      return props.scrollPadding;
    },
    paddingRight: 0,
    boxShadow: function boxShadow(props) {
      return props.isShadow ? props.shadow : 'none';
    }
  },
  container: {
    width: '100%',
    overflowY: 'hidden',
    boxSizing: 'border-box',
    display: 'flex'
  },
  subcontainer: {
    overflowY: 'auto',
    flex: '1',
    scrollbarColor: function scrollbarColor(props) {
      return props.scrollColor + ' transparent';
    },
    scrollbarWidth: 'thin',
    '&::-webkit-scrollbar': {
      width: function width(props) {
        return props.scrollWidth;
      },
      background: 'transparent'
    },
    '&::-webkit-scrollbar-track': {
      background: 'transparent'
    },
    '&::-webkit-scrollbar-thumb': {
      background: function background(props) {
        return props.scrollColor;
      },
      borderRadius: 5,
      overflow: 'hidden',
      '&:hover': {
        background: function background(props) {
          return props.scrollColorHover;
        }
      }
    }
  }
};

var _default = (0, _reactJss["default"])(styles)(ShadowScrollComponent);

exports["default"] = _default;